# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 ZestyBeanz Technologies Pvt. Ltd.
#    (http://wwww.zbeanztech.com)
#    contact@zbeanztech.com
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
##
##############################################################################

from osv import fields, osv
from tools.translate import _
#
#class sale_order(osv.osv):
#    _inherit = "sale.order"
#
#sale_order()

class sale_order_line(osv.osv):
    _inherit = "sale.order.line"

    def _workload_time(self, cr, uid, ids, prop, unknow_none, unknow_dict):
        res = {}
        for line in self.browse(cr, uid, ids):
            work_time=0
            if line.product_id:
                bom_id = self.pool.get('mrp.bom')._bom_find(cr, uid, line.product_id.id, line.product_uom.id)
                if bom_id :
                    bom_obj=self.pool.get('mrp.bom').browse(cr,uid,bom_id)
                    if bom_obj.routing_id:
                        for bom_line in bom_obj.routing_id.workcenter_lines :
                            total_work_time=bom_line.hour_nbr*bom_line.workcenter_id.capacity_per_cycle
                            work_time += total_work_time
                    if bom_obj.product_qty:
                        work_time=work_time/bom_obj.product_qty
                    else:
                         work_time=0
            work_time=work_time*line.product_uom_qty

            res[line.id] = work_time
        return res
    _columns = {

                'workload_time': fields.function(_workload_time, method=True, string='Workload', type="float",
            digits=(16,6), store=True),
                }

sale_order_line()